from typing import Tuple, Set, Iterable, List

class PaintColor:
    NormalStart = 0
    NormalEnd = 1
    NormalBorder = 2
    HotStart = 3
    HotEnd = 4
    HotBorder = 5
    PressedStart = 6
    PressedEnd = 7
    PressedBorder = 8
    TextEnabled = 9
    TextDisabled = 10
    MouseOverControlStart = 11
    MouseOverControlEnd = 12
    MouseOverControlBorder = 13
    ActiveCaption = 14
    InactiveCaption = 15
    PanelBackground = 16
    ActiveViewportTitle = 17
    InactiveViewportTitle = 18
class WidgetColor:
    UAxisColor = 0
    VAxisColor = 1
    WAxisColor = 2
class AppearanceSettingsState:
    @property
    def DefaultFontFaceName (self) -> str: ...
    @DefaultFontFaceName.setter
    def DefaultFontFaceName (self, value : str) -> None: ...
    @property
    def DefaultLayerColor (self) -> Color: ...
    @DefaultLayerColor.setter
    def DefaultLayerColor (self, value : Color) -> None: ...
    @property
    def SelectedObjectColor (self) -> Color: ...
    @SelectedObjectColor.setter
    def SelectedObjectColor (self, value : Color) -> None: ...
    @property
    def LockedObjectColor (self) -> Color: ...
    @LockedObjectColor.setter
    def LockedObjectColor (self, value : Color) -> None: ...
    @property
    def WorldCoordIconXAxisColor (self) -> Color: ...
    @WorldCoordIconXAxisColor.setter
    def WorldCoordIconXAxisColor (self, value : Color) -> None: ...
    @property
    def WorldCoordIconYAxisColor (self) -> Color: ...
    @WorldCoordIconYAxisColor.setter
    def WorldCoordIconYAxisColor (self, value : Color) -> None: ...
    @property
    def WorldCoordIconZAxisColor (self) -> Color: ...
    @WorldCoordIconZAxisColor.setter
    def WorldCoordIconZAxisColor (self, value : Color) -> None: ...
    @property
    def TrackingColor (self) -> Color: ...
    @TrackingColor.setter
    def TrackingColor (self, value : Color) -> None: ...
    @property
    def FeedbackColor (self) -> Color: ...
    @FeedbackColor.setter
    def FeedbackColor (self, value : Color) -> None: ...
    @property
    def DefaultObjectColor (self) -> Color: ...
    @DefaultObjectColor.setter
    def DefaultObjectColor (self, value : Color) -> None: ...
    @property
    def ViewportBackgroundColor (self) -> Color: ...
    @ViewportBackgroundColor.setter
    def ViewportBackgroundColor (self, value : Color) -> None: ...
    @property
    def FrameBackgroundColor (self) -> Color: ...
    @FrameBackgroundColor.setter
    def FrameBackgroundColor (self, value : Color) -> None: ...
    @property
    def CommandPromptTextColor (self) -> Color: ...
    @CommandPromptTextColor.setter
    def CommandPromptTextColor (self, value : Color) -> None: ...
    @property
    def CommandPromptHypertextColor (self) -> Color: ...
    @CommandPromptHypertextColor.setter
    def CommandPromptHypertextColor (self, value : Color) -> None: ...
    @property
    def CommandPromptBackgroundColor (self) -> Color: ...
    @CommandPromptBackgroundColor.setter
    def CommandPromptBackgroundColor (self, value : Color) -> None: ...
    @property
    def CrosshairColor (self) -> Color: ...
    @CrosshairColor.setter
    def CrosshairColor (self, value : Color) -> None: ...
    @property
    def PageviewPaperColor (self) -> Color: ...
    @PageviewPaperColor.setter
    def PageviewPaperColor (self, value : Color) -> None: ...
    @property
    def CurrentLayerBackgroundColor (self) -> Color: ...
    @CurrentLayerBackgroundColor.setter
    def CurrentLayerBackgroundColor (self, value : Color) -> None: ...
    @property
    def EchoPromptsToHistoryWindow (self) -> bool: ...
    @EchoPromptsToHistoryWindow.setter
    def EchoPromptsToHistoryWindow (self, value : bool) -> None: ...
    @property
    def EchoCommandsToHistoryWindow (self) -> bool: ...
    @EchoCommandsToHistoryWindow.setter
    def EchoCommandsToHistoryWindow (self, value : bool) -> None: ...
    @property
    def ShowFullPathInTitleBar (self) -> bool: ...
    @ShowFullPathInTitleBar.setter
    def ShowFullPathInTitleBar (self, value : bool) -> None: ...
    @property
    def ShowCrosshairs (self) -> bool: ...
    @ShowCrosshairs.setter
    def ShowCrosshairs (self, value : bool) -> None: ...
    @property
    def GridThinLineColor (self) -> Color: ...
    @GridThinLineColor.setter
    def GridThinLineColor (self, value : Color) -> None: ...
    @property
    def GridThickLineColor (self) -> Color: ...
    @GridThickLineColor.setter
    def GridThickLineColor (self, value : Color) -> None: ...
    @property
    def GridXAxisLineColor (self) -> Color: ...
    @GridXAxisLineColor.setter
    def GridXAxisLineColor (self, value : Color) -> None: ...
    @property
    def GridYAxisLineColor (self) -> Color: ...
    @GridYAxisLineColor.setter
    def GridYAxisLineColor (self, value : Color) -> None: ...
    @property
    def GridZAxisLineColor (self) -> Color: ...
    @GridZAxisLineColor.setter
    def GridZAxisLineColor (self, value : Color) -> None: ...
class CommandPromptPosition:
    Top = 0
    Bottom = 1
    Floating = 2
    Hidden = 3
class AppearanceSettings:
    def GetDefaultState () -> AppearanceSettingsState: ...
    def GetCurrentState () -> AppearanceSettingsState: ...
    def RestoreDefaults () -> None: ...
    def UpdateFromState (state : AppearanceSettingsState) -> None: ...
    @property
    def DefaultFontFaceName () -> str: ...
    def GetPaintColor (whichColor : PaintColor) -> Color: ...
    def SetPaintColor (whichColor : PaintColor, c : Color) -> None: ...
    def SetPaintColor (whichColor : PaintColor, c : Color, forceUiUpdate : bool) -> None: ...
    @property
    def UsePaintColors () -> bool: ...
    def GetWidgetColor (whichColor : WidgetColor) -> Color: ...
    def SetWidgetColor (whichColor : WidgetColor, c : Color) -> None: ...
    def SetWidgetColor (whichColor : WidgetColor, c : Color, forceUiUpdate : bool) -> None: ...
    @property
    def DefaultLayerColor () -> Color: ...
    @DefaultLayerColor.setter
    def DefaultLayerColor (value : Color) -> None: ...
    @property
    def SelectedObjectColor () -> Color: ...
    @SelectedObjectColor.setter
    def SelectedObjectColor (value : Color) -> None: ...
    @property
    def LockedObjectColor () -> Color: ...
    @LockedObjectColor.setter
    def LockedObjectColor (value : Color) -> None: ...
    @property
    def WorldCoordIconXAxisColor () -> Color: ...
    @WorldCoordIconXAxisColor.setter
    def WorldCoordIconXAxisColor (value : Color) -> None: ...
    @property
    def WorldCoordIconYAxisColor () -> Color: ...
    @WorldCoordIconYAxisColor.setter
    def WorldCoordIconYAxisColor (value : Color) -> None: ...
    @property
    def WorldCoordIconZAxisColor () -> Color: ...
    @WorldCoordIconZAxisColor.setter
    def WorldCoordIconZAxisColor (value : Color) -> None: ...
    @property
    def TrackingColor () -> Color: ...
    @TrackingColor.setter
    def TrackingColor (value : Color) -> None: ...
    @property
    def FeedbackColor () -> Color: ...
    @FeedbackColor.setter
    def FeedbackColor (value : Color) -> None: ...
    @property
    def DefaultObjectColor () -> Color: ...
    @DefaultObjectColor.setter
    def DefaultObjectColor (value : Color) -> None: ...
    @property
    def ViewportBackgroundColor () -> Color: ...
    @ViewportBackgroundColor.setter
    def ViewportBackgroundColor (value : Color) -> None: ...
    @property
    def FrameBackgroundColor () -> Color: ...
    @FrameBackgroundColor.setter
    def FrameBackgroundColor (value : Color) -> None: ...
    @property
    def CommandPromptTextColor () -> Color: ...
    @CommandPromptTextColor.setter
    def CommandPromptTextColor (value : Color) -> None: ...
    @property
    def CommandPromptHypertextColor () -> Color: ...
    @CommandPromptHypertextColor.setter
    def CommandPromptHypertextColor (value : Color) -> None: ...
    @property
    def CommandPromptBackgroundColor () -> Color: ...
    @CommandPromptBackgroundColor.setter
    def CommandPromptBackgroundColor (value : Color) -> None: ...
    @property
    def CrosshairColor () -> Color: ...
    @CrosshairColor.setter
    def CrosshairColor (value : Color) -> None: ...
    @property
    def PageviewPaperColor () -> Color: ...
    @PageviewPaperColor.setter
    def PageviewPaperColor (value : Color) -> None: ...
    @property
    def CurrentLayerBackgroundColor () -> Color: ...
    @CurrentLayerBackgroundColor.setter
    def CurrentLayerBackgroundColor (value : Color) -> None: ...
    @property
    def EditCandidateColor () -> Color: ...
    @EditCandidateColor.setter
    def EditCandidateColor (value : Color) -> None: ...
    @property
    def GridThinLineColor () -> Color: ...
    @GridThinLineColor.setter
    def GridThinLineColor (value : Color) -> None: ...
    @property
    def GridThickLineColor () -> Color: ...
    @GridThickLineColor.setter
    def GridThickLineColor (value : Color) -> None: ...
    @property
    def GridXAxisLineColor () -> Color: ...
    @GridXAxisLineColor.setter
    def GridXAxisLineColor (value : Color) -> None: ...
    @property
    def GridYAxisLineColor () -> Color: ...
    @GridYAxisLineColor.setter
    def GridYAxisLineColor (value : Color) -> None: ...
    @property
    def GridZAxisLineColor () -> Color: ...
    @GridZAxisLineColor.setter
    def GridZAxisLineColor (value : Color) -> None: ...
    @property
    def CommandPromptPosition () -> CommandPromptPosition: ...
    @CommandPromptPosition.setter
    def CommandPromptPosition (value : CommandPromptPosition) -> None: ...
    @property
    def EchoPromptsToHistoryWindow () -> bool: ...
    @EchoPromptsToHistoryWindow.setter
    def EchoPromptsToHistoryWindow (value : bool) -> None: ...
    @property
    def EchoCommandsToHistoryWindow () -> bool: ...
    @EchoCommandsToHistoryWindow.setter
    def EchoCommandsToHistoryWindow (value : bool) -> None: ...
    @property
    def ShowFullPathInTitleBar () -> bool: ...
    @ShowFullPathInTitleBar.setter
    def ShowFullPathInTitleBar (value : bool) -> None: ...
    @property
    def ShowCrosshairs () -> bool: ...
    @ShowCrosshairs.setter
    def ShowCrosshairs (value : bool) -> None: ...
    @property
    def ShowSideBar () -> bool: ...
    @ShowSideBar.setter
    def ShowSideBar (value : bool) -> None: ...
    @property
    def MenuVisible () -> bool: ...
    @MenuVisible.setter
    def MenuVisible (value : bool) -> None: ...
    @property
    def LanguageIdentifier () -> int: ...
    @LanguageIdentifier.setter
    def LanguageIdentifier (value : int) -> None: ...
    @property
    def PreviousLanguageIdentifier () -> int: ...
    @PreviousLanguageIdentifier.setter
    def PreviousLanguageIdentifier (value : int) -> None: ...
    def InitialMainWindowPosition () -> Tuple[bool, Rectangle]: ...
class CommandAliasList:
    @property
    def Count () -> int: ...
    def GetNames () -> Set(str): ...
    def Clear () -> None: ...
    def GetMacro (alias : str) -> str: ...
    def SetMacro (alias : str, macro : str) -> bool: ...
    def Add (alias : str, macro : str) -> bool: ...
    def Delete (alias : str) -> bool: ...
    def IsAlias (alias : str) -> bool: ...
    def ToDictionary () -> Dictionary: ...
    def IsDefault () -> bool: ...
    def GetDefaults () -> Dictionary: ...
class EdgeAnalysisSettingsState:
    @property
    def ShowEdgeColor (self) -> Color: ...
    @ShowEdgeColor.setter
    def ShowEdgeColor (self, value : Color) -> None: ...
    @property
    def ShowEdges (self) -> int: ...
    @ShowEdges.setter
    def ShowEdges (self, value : int) -> None: ...
class EdgeAnalysisSettings:
    def GetDefaultState () -> EdgeAnalysisSettingsState: ...
    def GetCurrentState () -> EdgeAnalysisSettingsState: ...
    def RestoreDefaults () -> None: ...
    def UpdateFromState (state : EdgeAnalysisSettingsState) -> None: ...
    @property
    def ShowEdgeColor () -> Color: ...
    @ShowEdgeColor.setter
    def ShowEdgeColor (value : Color) -> None: ...
    @property
    def ShowEdges () -> int: ...
    @ShowEdges.setter
    def ShowEdges (value : int) -> None: ...
class FileSettingsState:
    @property
    def AutoSaveInterval (self) -> TimeSpan: ...
    @AutoSaveInterval.setter
    def AutoSaveInterval (self, value : TimeSpan) -> None: ...
    @property
    def AutoSaveEnabled (self) -> bool: ...
    @AutoSaveEnabled.setter
    def AutoSaveEnabled (self, value : bool) -> None: ...
    @property
    def AutoSaveMeshes (self) -> bool: ...
    @AutoSaveMeshes.setter
    def AutoSaveMeshes (self, value : bool) -> None: ...
    @property
    def SaveViewChanges (self) -> bool: ...
    @SaveViewChanges.setter
    def SaveViewChanges (self, value : bool) -> None: ...
    @property
    def FileLockingEnabled (self) -> bool: ...
    @FileLockingEnabled.setter
    def FileLockingEnabled (self, value : bool) -> None: ...
    @property
    def FileLockingOpenWarning (self) -> bool: ...
    @FileLockingOpenWarning.setter
    def FileLockingOpenWarning (self, value : bool) -> None: ...
    @property
    def ClipboardCopyToPreviousRhinoVersion (self) -> bool: ...
    @ClipboardCopyToPreviousRhinoVersion.setter
    def ClipboardCopyToPreviousRhinoVersion (self, value : bool) -> None: ...
    @property
    def ClipboardOnExit (self) -> ClipboardState: ...
    @ClipboardOnExit.setter
    def ClipboardOnExit (self, value : ClipboardState) -> None: ...
    @property
    def CreateBackupFiles (self) -> bool: ...
    @CreateBackupFiles.setter
    def CreateBackupFiles (self, value : bool) -> None: ...
class FileSettings:
    def GetDefaultState () -> FileSettingsState: ...
    def GetCurrentState () -> FileSettingsState: ...
    def GetDataFolder (currentUser : bool) -> str: ...
    def RecentlyOpenedFiles () -> Set(str): ...
    def AddSearchPath (folder : str, index : int) -> int: ...
    def DeleteSearchPath (folder : str) -> bool: ...
    def FindFile (fileName : str) -> str: ...
    @property
    def SearchPathCount () -> int: ...
    def GetSearchPaths () -> Set(str): ...
    @property
    def WorkingFolder () -> str: ...
    @WorkingFolder.setter
    def WorkingFolder (value : str) -> None: ...
    @property
    def TemplateFolder () -> str: ...
    @TemplateFolder.setter
    def TemplateFolder (value : str) -> None: ...
    @property
    def TemplateFile () -> str: ...
    @TemplateFile.setter
    def TemplateFile (value : str) -> None: ...
    @property
    def AutoSaveFile () -> str: ...
    @AutoSaveFile.setter
    def AutoSaveFile (value : str) -> None: ...
    @property
    def AutoSaveInterval () -> TimeSpan: ...
    @AutoSaveInterval.setter
    def AutoSaveInterval (value : TimeSpan) -> None: ...
    @property
    def AutoSaveEnabled () -> bool: ...
    @AutoSaveEnabled.setter
    def AutoSaveEnabled (value : bool) -> None: ...
    @property
    def AutoSaveMeshes () -> bool: ...
    @AutoSaveMeshes.setter
    def AutoSaveMeshes (value : bool) -> None: ...
    def AutoSaveBeforeCommands () -> Set(str): ...
    def SetAutoSaveBeforeCommands (commands : Set(str)) -> None: ...
    @property
    def SaveViewChanges () -> bool: ...
    @SaveViewChanges.setter
    def SaveViewChanges (value : bool) -> None: ...
    @property
    def FileLockingEnabled () -> bool: ...
    @FileLockingEnabled.setter
    def FileLockingEnabled (value : bool) -> None: ...
    @property
    def FileLockingOpenWarning () -> bool: ...
    @FileLockingOpenWarning.setter
    def FileLockingOpenWarning (value : bool) -> None: ...
    @property
    def CreateBackupFiles () -> bool: ...
    @CreateBackupFiles.setter
    def CreateBackupFiles (value : bool) -> None: ...
    @property
    def ClipboardCopyToPreviousRhinoVersion () -> bool: ...
    @ClipboardCopyToPreviousRhinoVersion.setter
    def ClipboardCopyToPreviousRhinoVersion (value : bool) -> None: ...
    @property
    def ClipboardOnExit () -> ClipboardState: ...
    @ClipboardOnExit.setter
    def ClipboardOnExit (value : ClipboardState) -> None: ...
    @property
    def ExecutableFolder () -> str: ...
    @property
    def InstallFolder () -> DirectoryInfo: ...
    @property
    def HelpFilePath () -> str: ...
    @property
    def LocalProfileDataFolder () -> str: ...
    @property
    def DefaultRuiFile () -> str: ...
class NeverRepeatList:
    @property
    def UseNeverRepeatList () -> bool: ...
    def SetList (commandNames : Set(str)) -> int: ...
    def CommandNames () -> Set(str): ...
class MouseSelectMode:
    Crossing = 0
    Window = 1
    Combo = 2
class MiddleMouseMode:
    PopupMenu = 0
    PopupToolbar = 1
    RunMacro = 2
class GeneralSettingsState:
    @property
    def MouseSelectMode (self) -> MouseSelectMode: ...
    @MouseSelectMode.setter
    def MouseSelectMode (self, value : MouseSelectMode) -> None: ...
    @property
    def MaximumPopupMenuLines (self) -> int: ...
    @MaximumPopupMenuLines.setter
    def MaximumPopupMenuLines (self, value : int) -> None: ...
    @property
    def MinimumUndoSteps (self) -> int: ...
    @MinimumUndoSteps.setter
    def MinimumUndoSteps (self, value : int) -> None: ...
    @property
    def MaximumUndoMemoryMb (self) -> int: ...
    @MaximumUndoMemoryMb.setter
    def MaximumUndoMemoryMb (self, value : int) -> None: ...
    @property
    def NewObjectIsoparmCount (self) -> int: ...
    @NewObjectIsoparmCount.setter
    def NewObjectIsoparmCount (self, value : int) -> None: ...
    @property
    def MiddleMouseMode (self) -> MiddleMouseMode: ...
    @MiddleMouseMode.setter
    def MiddleMouseMode (self, value : MiddleMouseMode) -> None: ...
    @property
    def MiddleMousePopupToolbar (self) -> str: ...
    @MiddleMousePopupToolbar.setter
    def MiddleMousePopupToolbar (self, value : str) -> None: ...
    @property
    def MiddleMouseMacro (self) -> str: ...
    @MiddleMouseMacro.setter
    def MiddleMouseMacro (self, value : str) -> None: ...
    @property
    def EnableContextMenu (self) -> bool: ...
    @EnableContextMenu.setter
    def EnableContextMenu (self, value : bool) -> None: ...
    @property
    def ContextMenuDelay (self) -> TimeSpan: ...
    @ContextMenuDelay.setter
    def ContextMenuDelay (self, value : TimeSpan) -> None: ...
    @property
    def AutoUpdateCommandHelp (self) -> bool: ...
    @AutoUpdateCommandHelp.setter
    def AutoUpdateCommandHelp (self, value : bool) -> None: ...
class GeneralSettings:
    def GetDefaultState () -> GeneralSettingsState: ...
    def GetCurrentState () -> GeneralSettingsState: ...
    @property
    def UseExtrusions () -> bool: ...
    @property
    def MouseSelectMode () -> MouseSelectMode: ...
    @MouseSelectMode.setter
    def MouseSelectMode (value : MouseSelectMode) -> None: ...
    @property
    def MaximumPopupMenuLines () -> int: ...
    @MaximumPopupMenuLines.setter
    def MaximumPopupMenuLines (value : int) -> None: ...
    @property
    def MinimumUndoSteps () -> int: ...
    @MinimumUndoSteps.setter
    def MinimumUndoSteps (value : int) -> None: ...
    @property
    def MaximumUndoMemoryMb () -> int: ...
    @MaximumUndoMemoryMb.setter
    def MaximumUndoMemoryMb (value : int) -> None: ...
    @property
    def NewObjectIsoparmCount () -> int: ...
    @NewObjectIsoparmCount.setter
    def NewObjectIsoparmCount (value : int) -> None: ...
    @property
    def MiddleMouseMode () -> MiddleMouseMode: ...
    @MiddleMouseMode.setter
    def MiddleMouseMode (value : MiddleMouseMode) -> None: ...
    @property
    def MiddleMousePopupToolbar () -> str: ...
    @MiddleMousePopupToolbar.setter
    def MiddleMousePopupToolbar (value : str) -> None: ...
    @property
    def MiddleMouseMacro () -> str: ...
    @MiddleMouseMacro.setter
    def MiddleMouseMacro (value : str) -> None: ...
    @property
    def EnableContextMenu () -> bool: ...
    @EnableContextMenu.setter
    def EnableContextMenu (value : bool) -> None: ...
    @property
    def ContextMenuDelay () -> TimeSpan: ...
    @ContextMenuDelay.setter
    def ContextMenuDelay (value : TimeSpan) -> None: ...
    @property
    def AutoUpdateCommandHelp () -> bool: ...
    @AutoUpdateCommandHelp.setter
    def AutoUpdateCommandHelp (value : bool) -> None: ...
class ClipboardState:
    KeepData = 0
    DeleteData = 1
    PromptWhenBig = 2
class CursorMode:
    None = 0
    BlackOnWhite = 1
    WhiteOnBlack = 2
class OsnapModes:
    None = 0
    Near = 2
    Focus = 8
    Center = 32
    Vertex = 64
    Knot = 128
    Quadrant = 512
    Midpoint = 2048
    Intersection = 8192
    End = 131072
    Perpendicular = 524288
    Tangent = 2097152
    Point = 134217728
class PointDisplayMode:
    WorldPoint = 0
    CplanePoint = 1
class ModelAidSettingsState:
    @property
    def GridSnap (self) -> bool: ...
    @GridSnap.setter
    def GridSnap (self, value : bool) -> None: ...
    @property
    def Ortho (self) -> bool: ...
    @Ortho.setter
    def Ortho (self, value : bool) -> None: ...
    @property
    def Planar (self) -> bool: ...
    @Planar.setter
    def Planar (self, value : bool) -> None: ...
    @property
    def ProjectSnapToCPlane (self) -> bool: ...
    @ProjectSnapToCPlane.setter
    def ProjectSnapToCPlane (self, value : bool) -> None: ...
    @property
    def UseHorizontalDialog (self) -> bool: ...
    @UseHorizontalDialog.setter
    def UseHorizontalDialog (self, value : bool) -> None: ...
    @property
    def ExtendTrimLines (self) -> bool: ...
    @ExtendTrimLines.setter
    def ExtendTrimLines (self, value : bool) -> None: ...
    @property
    def ExtendToApparentIntersection (self) -> bool: ...
    @ExtendToApparentIntersection.setter
    def ExtendToApparentIntersection (self, value : bool) -> None: ...
    @property
    def AltPlusArrow (self) -> bool: ...
    @AltPlusArrow.setter
    def AltPlusArrow (self, value : bool) -> None: ...
    @property
    def DisplayControlPolygon (self) -> bool: ...
    @DisplayControlPolygon.setter
    def DisplayControlPolygon (self, value : bool) -> None: ...
    @property
    def HighlightControlPolygon (self) -> bool: ...
    @HighlightControlPolygon.setter
    def HighlightControlPolygon (self, value : bool) -> None: ...
    @property
    def Osnap (self) -> bool: ...
    @Osnap.setter
    def Osnap (self, value : bool) -> None: ...
    @property
    def SnapToLocked (self) -> bool: ...
    @SnapToLocked.setter
    def SnapToLocked (self, value : bool) -> None: ...
    @property
    def UniversalConstructionPlaneMode (self) -> bool: ...
    @UniversalConstructionPlaneMode.setter
    def UniversalConstructionPlaneMode (self, value : bool) -> None: ...
    @property
    def OrthoAngle (self) -> float: ...
    @OrthoAngle.setter
    def OrthoAngle (self, value : float) -> None: ...
    @property
    def NudgeKeyStep (self) -> float: ...
    @NudgeKeyStep.setter
    def NudgeKeyStep (self, value : float) -> None: ...
    @property
    def CtrlNudgeKeyStep (self) -> float: ...
    @CtrlNudgeKeyStep.setter
    def CtrlNudgeKeyStep (self, value : float) -> None: ...
    @property
    def ShiftNudgeKeyStep (self) -> float: ...
    @ShiftNudgeKeyStep.setter
    def ShiftNudgeKeyStep (self, value : float) -> None: ...
    @property
    def OsnapPickboxRadius (self) -> int: ...
    @OsnapPickboxRadius.setter
    def OsnapPickboxRadius (self, value : int) -> None: ...
    @property
    def NudgeMode (self) -> int: ...
    @NudgeMode.setter
    def NudgeMode (self, value : int) -> None: ...
    @property
    def ControlPolygonDisplayDensity (self) -> int: ...
    @ControlPolygonDisplayDensity.setter
    def ControlPolygonDisplayDensity (self, value : int) -> None: ...
    @property
    def OsnapCursorMode (self) -> CursorMode: ...
    @OsnapCursorMode.setter
    def OsnapCursorMode (self, value : CursorMode) -> None: ...
    @property
    def OsnapModes (self) -> OsnapModes: ...
    @OsnapModes.setter
    def OsnapModes (self, value : OsnapModes) -> None: ...
    @property
    def MousePickboxRadius (self) -> int: ...
    @MousePickboxRadius.setter
    def MousePickboxRadius (self, value : int) -> None: ...
    @property
    def PointDisplay (self) -> PointDisplayMode: ...
    @PointDisplay.setter
    def PointDisplay (self, value : PointDisplayMode) -> None: ...
class ModelAidSettings:
    def GetCurrentState () -> ModelAidSettingsState: ...
    def GetDefaultState () -> ModelAidSettingsState: ...
    def UpdateFromState (state : ModelAidSettingsState) -> None: ...
    @property
    def GridSnap () -> bool: ...
    @GridSnap.setter
    def GridSnap (value : bool) -> None: ...
    @property
    def Ortho () -> bool: ...
    @Ortho.setter
    def Ortho (value : bool) -> None: ...
    @property
    def Planar () -> bool: ...
    @Planar.setter
    def Planar (value : bool) -> None: ...
    @property
    def ProjectSnapToCPlane () -> bool: ...
    @ProjectSnapToCPlane.setter
    def ProjectSnapToCPlane (value : bool) -> None: ...
    @property
    def UseHorizontalDialog () -> bool: ...
    @UseHorizontalDialog.setter
    def UseHorizontalDialog (value : bool) -> None: ...
    @property
    def ExtendTrimLines () -> bool: ...
    @ExtendTrimLines.setter
    def ExtendTrimLines (value : bool) -> None: ...
    @property
    def ExtendToApparentIntersection () -> bool: ...
    @ExtendToApparentIntersection.setter
    def ExtendToApparentIntersection (value : bool) -> None: ...
    @property
    def AltPlusArrow () -> bool: ...
    @AltPlusArrow.setter
    def AltPlusArrow (value : bool) -> None: ...
    @property
    def DisplayControlPolygon () -> bool: ...
    @DisplayControlPolygon.setter
    def DisplayControlPolygon (value : bool) -> None: ...
    @property
    def HighlightControlPolygon () -> bool: ...
    @HighlightControlPolygon.setter
    def HighlightControlPolygon (value : bool) -> None: ...
    @property
    def Osnap () -> bool: ...
    @Osnap.setter
    def Osnap (value : bool) -> None: ...
    @property
    def SnapToLocked () -> bool: ...
    @SnapToLocked.setter
    def SnapToLocked (value : bool) -> None: ...
    @property
    def UniversalConstructionPlaneMode () -> bool: ...
    @UniversalConstructionPlaneMode.setter
    def UniversalConstructionPlaneMode (value : bool) -> None: ...
    @property
    def OrthoAngle () -> float: ...
    @OrthoAngle.setter
    def OrthoAngle (value : float) -> None: ...
    @property
    def NudgeKeyStep () -> float: ...
    @NudgeKeyStep.setter
    def NudgeKeyStep (value : float) -> None: ...
    @property
    def CtrlNudgeKeyStep () -> float: ...
    @CtrlNudgeKeyStep.setter
    def CtrlNudgeKeyStep (value : float) -> None: ...
    @property
    def ShiftNudgeKeyStep () -> float: ...
    @ShiftNudgeKeyStep.setter
    def ShiftNudgeKeyStep (value : float) -> None: ...
    @property
    def OsnapPickboxRadius () -> int: ...
    @OsnapPickboxRadius.setter
    def OsnapPickboxRadius (value : int) -> None: ...
    @property
    def NudgeMode () -> int: ...
    @NudgeMode.setter
    def NudgeMode (value : int) -> None: ...
    @property
    def ControlPolygonDisplayDensity () -> int: ...
    @ControlPolygonDisplayDensity.setter
    def ControlPolygonDisplayDensity (value : int) -> None: ...
    @property
    def OsnapCursorMode () -> CursorMode: ...
    @OsnapCursorMode.setter
    def OsnapCursorMode (value : CursorMode) -> None: ...
    @property
    def OsnapModes () -> OsnapModes: ...
    @OsnapModes.setter
    def OsnapModes (value : OsnapModes) -> None: ...
    @property
    def MousePickboxRadius () -> int: ...
    @MousePickboxRadius.setter
    def MousePickboxRadius (value : int) -> None: ...
    @property
    def PointDisplay () -> PointDisplayMode: ...
    @PointDisplay.setter
    def PointDisplay (value : PointDisplayMode) -> None: ...
    @property
    def AutoGumballEnabled () -> bool: ...
    @AutoGumballEnabled.setter
    def AutoGumballEnabled (value : bool) -> None: ...
    @property
    def SnappyGumballEnabled () -> bool: ...
    @SnappyGumballEnabled.setter
    def SnappyGumballEnabled (value : bool) -> None: ...
class ViewSettingsState:
    @property
    def PanScreenFraction (self) -> float: ...
    @PanScreenFraction.setter
    def PanScreenFraction (self, value : float) -> None: ...
    @property
    def PanReverseKeyboardAction (self) -> bool: ...
    @PanReverseKeyboardAction.setter
    def PanReverseKeyboardAction (self, value : bool) -> None: ...
    @property
    def AlwaysPanParallelViews (self) -> bool: ...
    @AlwaysPanParallelViews.setter
    def AlwaysPanParallelViews (self, value : bool) -> None: ...
    @property
    def ZoomScale (self) -> float: ...
    @ZoomScale.setter
    def ZoomScale (self, value : float) -> None: ...
    @property
    def ZoomExtentsParallelViewBorder (self) -> float: ...
    @ZoomExtentsParallelViewBorder.setter
    def ZoomExtentsParallelViewBorder (self, value : float) -> None: ...
    @property
    def ZoomExtentsPerspectiveViewBorder (self) -> float: ...
    @ZoomExtentsPerspectiveViewBorder.setter
    def ZoomExtentsPerspectiveViewBorder (self, value : float) -> None: ...
    @property
    def RotateCircleIncrement (self) -> int: ...
    @RotateCircleIncrement.setter
    def RotateCircleIncrement (self, value : int) -> None: ...
    @property
    def RotateReverseKeyboard (self) -> bool: ...
    @RotateReverseKeyboard.setter
    def RotateReverseKeyboard (self, value : bool) -> None: ...
    @property
    def RotateToView (self) -> bool: ...
    @RotateToView.setter
    def RotateToView (self, value : bool) -> None: ...
    @property
    def DefinedViewSetCPlane (self) -> bool: ...
    @DefinedViewSetCPlane.setter
    def DefinedViewSetCPlane (self, value : bool) -> None: ...
    @property
    def DefinedViewSetProjection (self) -> bool: ...
    @DefinedViewSetProjection.setter
    def DefinedViewSetProjection (self, value : bool) -> None: ...
    @property
    def SingleClickMaximize (self) -> bool: ...
    @SingleClickMaximize.setter
    def SingleClickMaximize (self, value : bool) -> None: ...
    @property
    def LinkedViewports (self) -> bool: ...
    @LinkedViewports.setter
    def LinkedViewports (self, value : bool) -> None: ...
class ViewSettings:
    def GetDefaultState () -> ViewSettingsState: ...
    def GetCurrentState () -> ViewSettingsState: ...
    def RestoreDefaults () -> None: ...
    def UpdateFromState (state : ViewSettingsState) -> None: ...
    @property
    def PanScreenFraction () -> float: ...
    @PanScreenFraction.setter
    def PanScreenFraction (value : float) -> None: ...
    @property
    def PanReverseKeyboardAction () -> bool: ...
    @PanReverseKeyboardAction.setter
    def PanReverseKeyboardAction (value : bool) -> None: ...
    @property
    def AlwaysPanParallelViews () -> bool: ...
    @AlwaysPanParallelViews.setter
    def AlwaysPanParallelViews (value : bool) -> None: ...
    @property
    def ZoomScale () -> float: ...
    @ZoomScale.setter
    def ZoomScale (value : float) -> None: ...
    @property
    def ZoomExtentsParallelViewBorder () -> float: ...
    @ZoomExtentsParallelViewBorder.setter
    def ZoomExtentsParallelViewBorder (value : float) -> None: ...
    @property
    def ZoomExtentsPerspectiveViewBorder () -> float: ...
    @ZoomExtentsPerspectiveViewBorder.setter
    def ZoomExtentsPerspectiveViewBorder (value : float) -> None: ...
    @property
    def RotateCircleIncrement () -> int: ...
    @RotateCircleIncrement.setter
    def RotateCircleIncrement (value : int) -> None: ...
    @property
    def RotateReverseKeyboard () -> bool: ...
    @RotateReverseKeyboard.setter
    def RotateReverseKeyboard (value : bool) -> None: ...
    @property
    def RotateToView () -> bool: ...
    @RotateToView.setter
    def RotateToView (value : bool) -> None: ...
    @property
    def DefinedViewSetCPlane () -> bool: ...
    @DefinedViewSetCPlane.setter
    def DefinedViewSetCPlane (value : bool) -> None: ...
    @property
    def DefinedViewSetProjection () -> bool: ...
    @DefinedViewSetProjection.setter
    def DefinedViewSetProjection (value : bool) -> None: ...
    @property
    def SingleClickMaximize () -> bool: ...
    @SingleClickMaximize.setter
    def SingleClickMaximize (value : bool) -> None: ...
    @property
    def LinkedViewports () -> bool: ...
    @LinkedViewports.setter
    def LinkedViewports (value : bool) -> None: ...
class OpenGLSettingsState:
    @property
    def AntialiasLevel (self) -> AntialiasLevel: ...
    @AntialiasLevel.setter
    def AntialiasLevel (self, value : AntialiasLevel) -> None: ...
class OpenGLSettings:
    def __init__(self): ...
    def GetDefaultState () -> OpenGLSettingsState: ...
    def GetCurrentState () -> OpenGLSettingsState: ...
    def RestoreDefaults () -> None: ...
    def UpdateFromState (state : OpenGLSettingsState) -> None: ...
    @property
    def AntialiasLevel () -> AntialiasLevel: ...
    @AntialiasLevel.setter
    def AntialiasLevel (value : AntialiasLevel) -> None: ...
class ShortcutKey:
    F1 = 0
    F2 = 1
    F3 = 2
    F4 = 3
    F5 = 4
    F6 = 5
    F7 = 6
    F8 = 7
    F9 = 8
    F10 = 9
    F11 = 10
    F12 = 11
    CtrlF1 = 12
    CtrlF2 = 13
    CtrlF3 = 14
    CtrlF4 = 15
    CtrlF5 = 16
    CtrlF6 = 17
    CtrlF7 = 18
    CtrlF8 = 19
    CtrlF9 = 20
    CtrlF10 = 21
    CtrlF11 = 22
    CtrlF12 = 23
    ShiftCtrlF1 = 24
    ShiftCtrlF2 = 25
    ShiftCtrlF3 = 26
    ShiftCtrlF4 = 27
    ShiftCtrlF5 = 28
    ShiftCtrlF6 = 29
    ShiftCtrlF7 = 30
    ShiftCtrlF8 = 31
    ShiftCtrlF9 = 32
    ShiftCtrlF10 = 33
    ShiftCtrlF11 = 34
    ShiftCtrlF12 = 35
    AltCtrlF1 = 36
    AltCtrlF2 = 37
    AltCtrlF3 = 38
    AltCtrlF4 = 39
    AltCtrlF5 = 40
    AltCtrlF6 = 41
    AltCtrlF7 = 42
    AltCtrlF8 = 43
    AltCtrlF9 = 44
    AltCtrlF10 = 45
    AltCtrlF11 = 46
    AltCtrlF12 = 47
    CtrlA = 48
    CtrlB = 49
    CtrlC = 50
    CtrlD = 51
    CtrlE = 52
    CtrlF = 53
    CtrlG = 54
    CtrlH = 55
    CtrlI = 56
    CtrlJ = 57
    CtrlK = 58
    CtrlL = 59
    CtrlM = 60
    CtrlN = 61
    CtrlO = 62
    CtrlP = 63
    CtrlQ = 64
    CtrlR = 65
    CtrlS = 66
    CtrlT = 67
    CtrlU = 68
    CtrlV = 69
    CtrlW = 70
    CtrlX = 71
    CtrlY = 72
    CtrlZ = 73
    ShiftCtrlA = 74
    ShiftCtrlB = 75
    ShiftCtrlC = 76
    ShiftCtrlD = 77
    ShiftCtrlE = 78
    ShiftCtrlF = 79
    ShiftCtrlG = 80
    ShiftCtrlH = 81
    ShiftCtrlI = 82
    ShiftCtrlJ = 83
    ShiftCtrlK = 84
    ShiftCtrlL = 85
    ShiftCtrlM = 86
    ShiftCtrlN = 87
    ShiftCtrlO = 88
    ShiftCtrlP = 89
    ShiftCtrlQ = 90
    ShiftCtrlR = 91
    ShiftCtrlS = 92
    ShiftCtrlT = 93
    ShiftCtrlU = 94
    ShiftCtrlV = 95
    ShiftCtrlW = 96
    ShiftCtrlX = 97
    ShiftCtrlY = 98
    ShiftCtrlZ = 99
    AltCtrlA = 100
    AltCtrlB = 101
    AltCtrlC = 102
    AltCtrlD = 103
    AltCtrlE = 104
    AltCtrlF = 105
    AltCtrlG = 106
    AltCtrlH = 107
    AltCtrlI = 108
    AltCtrlJ = 109
    AltCtrlK = 110
    AltCtrlL = 111
    AltCtrlM = 112
    AltCtrlN = 113
    AltCtrlO = 114
    AltCtrlP = 115
    AltCtrlQ = 116
    AltCtrlR = 117
    AltCtrlS = 118
    AltCtrlT = 119
    AltCtrlU = 120
    AltCtrlV = 121
    AltCtrlW = 122
    AltCtrlX = 123
    AltCtrlY = 124
    AltCtrlZ = 125
    Ctrl0 = 126
    Ctrl1 = 127
    Ctrl2 = 128
    Ctrl3 = 129
    Ctrl4 = 130
    Ctrl5 = 131
    Ctrl6 = 132
    Ctrl7 = 133
    Ctrl8 = 134
    Ctrl9 = 135
    ShiftCtrl0 = 136
    ShiftCtrl1 = 137
    ShiftCtrl2 = 138
    ShiftCtrl3 = 139
    ShiftCtrl4 = 140
    ShiftCtrl5 = 141
    ShiftCtrl6 = 142
    ShiftCtrl7 = 143
    ShiftCtrl8 = 144
    ShiftCtrl9 = 145
    AltCtrl0 = 146
    AltCtrl1 = 147
    AltCtrl2 = 148
    AltCtrl3 = 149
    AltCtrl4 = 150
    AltCtrl5 = 151
    AltCtrl6 = 152
    AltCtrl7 = 153
    AltCtrl8 = 154
    AltCtrl9 = 155
    Home = 156
    End = 157
    CtrlHome = 158
    CtrlEnd = 159
    ShiftHome = 160
    ShiftEnd = 161
    ShiftCtrlHome = 162
    ShiftCtrlEnd = 163
    AltCtrlHome = 164
    AltCtrlEnd = 165
    PageUp = 166
    PageDown = 167
    ShiftPageUp = 168
    ShiftPageDown = 169
    CtrlPageUp = 170
    CtrlPageDown = 171
    ShiftCtrlPageUp = 172
    ShiftCtrlPageDown = 173
    AltCtrlPageUp = 174
    AltCtrlPageDown = 175
class ShortcutKeySettings:
    def GetMacro (key : ShortcutKey) -> str: ...
    def SetMacro (key : ShortcutKey, macro : str) -> None: ...
class SmartTrackSettingsState:
    @property
    def UseSmartTrack (self) -> bool: ...
    @UseSmartTrack.setter
    def UseSmartTrack (self, value : bool) -> None: ...
    @property
    def UseDottedLines (self) -> bool: ...
    @UseDottedLines.setter
    def UseDottedLines (self, value : bool) -> None: ...
    @property
    def SmartOrtho (self) -> bool: ...
    @SmartOrtho.setter
    def SmartOrtho (self, value : bool) -> None: ...
    @property
    def SmartTangents (self) -> bool: ...
    @SmartTangents.setter
    def SmartTangents (self, value : bool) -> None: ...
    @property
    def ActivationDelayMilliseconds (self) -> int: ...
    @ActivationDelayMilliseconds.setter
    def ActivationDelayMilliseconds (self, value : int) -> None: ...
    @property
    def MaxSmartPoints () -> int: ...
    @MaxSmartPoints.setter
    def MaxSmartPoints (value : int) -> None: ...
    @property
    def LineColor (self) -> Color: ...
    @LineColor.setter
    def LineColor (self, value : Color) -> None: ...
    @property
    def TanPerpLineColor (self) -> Color: ...
    @TanPerpLineColor.setter
    def TanPerpLineColor (self, value : Color) -> None: ...
    @property
    def PointColor (self) -> Color: ...
    @PointColor.setter
    def PointColor (self, value : Color) -> None: ...
    @property
    def ActivePointColor (self) -> Color: ...
    @ActivePointColor.setter
    def ActivePointColor (self, value : Color) -> None: ...
class SmartTrackSettings:
    def GetCurrentState () -> SmartTrackSettingsState: ...
    def GetDefaultState () -> SmartTrackSettingsState: ...
    def UpdateFromState (state : SmartTrackSettingsState) -> None: ...
    @property
    def UseSmartTrack () -> bool: ...
    @UseSmartTrack.setter
    def UseSmartTrack (value : bool) -> None: ...
    @property
    def UseDottedLines () -> bool: ...
    @UseDottedLines.setter
    def UseDottedLines (value : bool) -> None: ...
    @property
    def SmartOrtho () -> bool: ...
    @SmartOrtho.setter
    def SmartOrtho (value : bool) -> None: ...
    @property
    def SmartTangents () -> bool: ...
    @SmartTangents.setter
    def SmartTangents (value : bool) -> None: ...
    @property
    def ActivationDelayMilliseconds () -> int: ...
    @ActivationDelayMilliseconds.setter
    def ActivationDelayMilliseconds (value : int) -> None: ...
    @property
    def MaxSmartPoints () -> int: ...
    @MaxSmartPoints.setter
    def MaxSmartPoints (value : int) -> None: ...
    @property
    def LineColor () -> Color: ...
    @LineColor.setter
    def LineColor (value : Color) -> None: ...
    @property
    def TanPerpLineColor () -> Color: ...
    @TanPerpLineColor.setter
    def TanPerpLineColor (value : Color) -> None: ...
    @property
    def PointColor () -> Color: ...
    @PointColor.setter
    def PointColor (value : Color) -> None: ...
    @property
    def ActivePointColor () -> Color: ...
    @ActivePointColor.setter
    def ActivePointColor (value : Color) -> None: ...
class CursorTooltipSettingsState:
    def __init__(self): ...
    @property
    def TooltipsEnabled (self) -> bool: ...
    @TooltipsEnabled.setter
    def TooltipsEnabled (self, value : bool) -> None: ...
    @property
    def Offset (self) -> Point: ...
    @Offset.setter
    def Offset (self, value : Point) -> None: ...
    @property
    def BackgroundColor (self) -> Color: ...
    @BackgroundColor.setter
    def BackgroundColor (self, value : Color) -> None: ...
    @property
    def TextColor (self) -> Color: ...
    @TextColor.setter
    def TextColor (self, value : Color) -> None: ...
    @property
    def OsnapPane (self) -> bool: ...
    @OsnapPane.setter
    def OsnapPane (self, value : bool) -> None: ...
    @property
    def DistancePane (self) -> bool: ...
    @DistancePane.setter
    def DistancePane (self, value : bool) -> None: ...
    @property
    def PointPane (self) -> bool: ...
    @PointPane.setter
    def PointPane (self, value : bool) -> None: ...
    @property
    def RelativePointPane (self) -> bool: ...
    @RelativePointPane.setter
    def RelativePointPane (self, value : bool) -> None: ...
    @property
    def CommandPromptPane (self) -> bool: ...
    @CommandPromptPane.setter
    def CommandPromptPane (self, value : bool) -> None: ...
    @property
    def AutoSuppress (self) -> bool: ...
    @AutoSuppress.setter
    def AutoSuppress (self, value : bool) -> None: ...
class CursorTooltipSettings:
    def GetCurrentState () -> CursorTooltipSettingsState: ...
    def GetDefaultState () -> CursorTooltipSettingsState: ...
    @property
    def TooltipsEnabled () -> bool: ...
    @TooltipsEnabled.setter
    def TooltipsEnabled (value : bool) -> None: ...
    @property
    def Offset () -> Point: ...
    @Offset.setter
    def Offset (value : Point) -> None: ...
    @property
    def BackgroundColor () -> Color: ...
    @BackgroundColor.setter
    def BackgroundColor (value : Color) -> None: ...
    @property
    def TextColor () -> Color: ...
    @TextColor.setter
    def TextColor (value : Color) -> None: ...
    @property
    def OsnapPane () -> bool: ...
    @OsnapPane.setter
    def OsnapPane (value : bool) -> None: ...
    @property
    def DistancePane () -> bool: ...
    @DistancePane.setter
    def DistancePane (value : bool) -> None: ...
    @property
    def PointPane () -> bool: ...
    @PointPane.setter
    def PointPane (value : bool) -> None: ...
    @property
    def RelativePointPane () -> bool: ...
    @RelativePointPane.setter
    def RelativePointPane (value : bool) -> None: ...
    @property
    def CommandPromptPane () -> bool: ...
    @CommandPromptPane.setter
    def CommandPromptPane (value : bool) -> None: ...
    @property
    def AutoSuppress () -> bool: ...
    @AutoSuppress.setter
    def AutoSuppress (value : bool) -> None: ...
class CurvatureAnalysisSettingsState:
    @property
    def GaussRange (self) -> Interval: ...
    @GaussRange.setter
    def GaussRange (self, value : Interval) -> None: ...
    @property
    def MeanRange (self) -> Interval: ...
    @MeanRange.setter
    def MeanRange (self, value : Interval) -> None: ...
    @property
    def MinRadiusRange (self) -> Interval: ...
    @MinRadiusRange.setter
    def MinRadiusRange (self, value : Interval) -> None: ...
    @property
    def MaxRadiusRange (self) -> Interval: ...
    @MaxRadiusRange.setter
    def MaxRadiusRange (self, value : Interval) -> None: ...
    @property
    def Style (self) -> CurvatureStyle: ...
    @Style.setter
    def Style (self, value : CurvatureStyle) -> None: ...
class CurvatureAnalysisSettings:
    def GetDefaultState () -> CurvatureAnalysisSettingsState: ...
    def GetCurrentState () -> CurvatureAnalysisSettingsState: ...
    def RestoreDefaults () -> None: ...
    def UpdateFromState (state : CurvatureAnalysisSettingsState) -> None: ...
    @property
    def GaussRange () -> Interval: ...
    @GaussRange.setter
    def GaussRange (value : Interval) -> None: ...
    @property
    def MeanRange () -> Interval: ...
    @MeanRange.setter
    def MeanRange (value : Interval) -> None: ...
    @property
    def MinRadiusRange () -> Interval: ...
    @MinRadiusRange.setter
    def MinRadiusRange (value : Interval) -> None: ...
    @property
    def MaxRadiusRange () -> Interval: ...
    @MaxRadiusRange.setter
    def MaxRadiusRange (value : Interval) -> None: ...
    @property
    def Style () -> CurvatureStyle: ...
    @Style.setter
    def Style (value : CurvatureStyle) -> None: ...
    def CalculateCurvatureAutoRange (meshes : Iterable[Mesh], settings : CurvatureAnalysisSettingsState) -> Tuple[bool, CurvatureAnalysisSettingsState]: ...
class HistorySettings:
    @property
    def RecordingEnabled () -> bool: ...
    @RecordingEnabled.setter
    def RecordingEnabled (value : bool) -> None: ...
    @property
    def UpdateEnabled () -> bool: ...
    @UpdateEnabled.setter
    def UpdateEnabled (value : bool) -> None: ...
    @property
    def ObjectLockingEnabled () -> bool: ...
    @ObjectLockingEnabled.setter
    def ObjectLockingEnabled (value : bool) -> None: ...
    @property
    def BrokenRecordWarningEnabled () -> bool: ...
    @BrokenRecordWarningEnabled.setter
    def BrokenRecordWarningEnabled (value : bool) -> None: ...
class LicenseNode:
    Standalone = 0
    Network = 1
    NetworkCheckedOut = 2
class Installation:
    Undefined = 0
    Commercial = 1
    Educational = 2
    EducationalLab = 3
    NotForResale = 4
    NotForResaleLab = 5
    Beta = 6
    BetaLab = 7
    Evaluation = 8
    Corporate = 9
    EvaluationTimed = 10
class CurvatureStyle:
    Gaussian = 0
    Mean = 1
    MinRadius = 2
    MaxRadius = 3
