from typing import Tuple, Set, Iterable, List

class UserData:
    def Dispose (self) -> None: ...
    @property
    def Description (self) -> str: ...
    @property
    def ShouldWrite (self) -> bool: ...
    def Copy (source : CommonObject, destination : CommonObject) -> None: ...
    def MoveUserDataFrom (objectWithUserData : CommonObject) -> Guid: ...
    def MoveUserDataTo (objectToGetUserData : CommonObject, id : Guid, append : bool) -> None: ...
    @property
    def Transform (self) -> Transform: ...
class UnknownUserData(UserData):
    def __init__(self, pointerNativeUserData : IntPtr): ...
class UserDataListEnumerator:
    def __init__(self, udl : UserDataList): ...
    @property
    def Current (self) -> UserData: ...
    def Dispose (self) -> None: ...
    def MoveNext (self) -> bool: ...
    def Reset (self) -> None: ...
class UserDataList:
    @property
    def Count (self) -> int: ...
    def Add (self, userdata : UserData) -> bool: ...
    def Remove (self, userdata : UserData) -> bool: ...
    def Find (self, userdataType : Type) -> UserData: ...
    @property
    def Item (self, index : int) -> UserData: ...
    def Contains (self, userdataId : Guid) -> bool: ...
    def GetEnumerator (self) -> IEnumerator: ...
    def Purge (self) -> None: ...
class UserDictionary(UserData):
    def __init__(self): ...
    @property
    def Dictionary (self) -> ArchivableDictionary: ...
    @property
    def Description (self) -> str: ...
    @property
    def ShouldWrite (self) -> bool: ...
class ClassIdAttribute:
    def __init__(self, id : str): ...
    @property
    def Id (self) -> Guid: ...
class CustomBrepObject(BrepObject):
class CustomCurveObject(CurveObject):
    def Dispose (self) -> None: ...
class GripStatus:
    @property
    def Culled (self) -> bool: ...
    @Culled.setter
    def Culled (self, value : bool) -> None: ...
    @property
    def Visible (self) -> bool: ...
class GripsDrawEventArgs(DrawEventArgs):
    @property
    def DrawStaticStuff (self) -> bool: ...
    @property
    def DrawDynamicStuff (self) -> bool: ...
    @property
    def ControlPolygonStyle (self) -> int: ...
    @ControlPolygonStyle.setter
    def ControlPolygonStyle (self, value : int) -> None: ...
    @property
    def GripColor (self) -> Color: ...
    @GripColor.setter
    def GripColor (self, value : Color) -> None: ...
    @property
    def LockedGripColor (self) -> Color: ...
    @LockedGripColor.setter
    def LockedGripColor (self, value : Color) -> None: ...
    @property
    def SelectedGripColor (self) -> Color: ...
    @SelectedGripColor.setter
    def SelectedGripColor (self, value : Color) -> None: ...
    @property
    def GripStatusCount (self) -> int: ...
    def GripStatus (self, index : int) -> GripStatus: ...
    def DrawControlPolygonLine (self, line : Line, startStatus : GripStatus, endStatus : GripStatus) -> None: ...
    def DrawControlPolygonLine (self, line : Line, startStatus : int, endStatus : int) -> None: ...
    def DrawControlPolygonLine (self, start : Point3d, end : Point3d, startStatus : int, endStatus : int) -> None: ...
    def RestoreViewportSettings (self) -> None: ...
class TurnOnGripsEventHandler:
    def __init__(self, object : Object, method : IntPtr): ...
    def Invoke (self, rhObj : RhinoObject) -> None: ...
    def BeginInvoke (self, rhObj : RhinoObject, callback : AsyncCallback, object : Object) -> IAsyncResult: ...
    def EndInvoke (self, result : IAsyncResult) -> None: ...
class CustomObjectGrips:
    def RegisterGripsEnabler (enabler : TurnOnGripsEventHandler, customGripsType : Type) -> None: ...
    @property
    def GripCount (self) -> int: ...
    def Grip (self, index : int) -> CustomGripObject: ...
    def Dragging () -> bool: ...
    @property
    def NewLocation (self) -> bool: ...
    @NewLocation.setter
    def NewLocation (self, value : bool) -> None: ...
    @property
    def GripsMoved (self) -> bool: ...
    @property
    def OwnerObject (self) -> RhinoObject: ...
    def Dispose (self) -> None: ...
class CustomMeshObject(MeshObject):
    def Dispose (self) -> None: ...
class CustomPointObject(PointObject):
    def Dispose (self) -> None: ...
class CustomGripObject(GripObject):
    def __init__(self): ...
    def Dispose (self) -> None: ...
    @property
    def Index (self) -> int: ...
    @Index.setter
    def Index (self, value : int) -> None: ...
    @property
    def OriginalLocation (self) -> Point3d: ...
    @OriginalLocation.setter
    def OriginalLocation (self, value : Point3d) -> None: ...
    @property
    def Weight (self) -> float: ...
    @Weight.setter
    def Weight (self, value : float) -> None: ...
    def NewLocation (self) -> None: ...
