from typing import Tuple, Set, Iterable, List

class StringParser:
    def __init__(self): ...
    def ParseLengthExpession (expression : str, parse_settings_in : StringParserSettings, output_unit_system : UnitSystem) -> Tuple[int, float]: ...
    def ParseLengthExpession (expression : str, start_offset : int, expression_length : int, parse_settings_in : StringParserSettings, output_unit_system : UnitSystem, parse_results : StringParserSettings, parsed_unit_system : UnitSystem) -> Tuple[int, float, StringParserSettings, UnitSystem]: ...
    def ParseAngleExpressionDegrees (expression : str) -> Tuple[bool, float]: ...
    def ParseAngleExpressionRadians (expression : str) -> Tuple[bool, float]: ...
    def ParseAngleExpession (expression : str, start_offset : int, expression_length : int, parse_settings_in : StringParserSettings, output_angle_unit_system : AngleUnitSystem, parse_results : StringParserSettings, parsed_unit_system : AngleUnitSystem) -> Tuple[int, float, StringParserSettings, AngleUnitSystem]: ...
    def ParseNumber (expression : str, max_count : int, settings_in : StringParserSettings, settings_out : StringParserSettings) -> Tuple[int, StringParserSettings, float]: ...
class StringParserSettings:
    def __init__(self): ...
    def Dispose (self) -> None: ...
    @property
    def DefaultParseSettings () -> StringParserSettings: ...
    @property
    def ParseSettingsRadians () -> StringParserSettings: ...
    @property
    def ParseSettingsDegrees () -> StringParserSettings: ...
    @property
    def ParseSettingsIntegerNumber () -> StringParserSettings: ...
    @property
    def ParseSettingsRationalNumber () -> StringParserSettings: ...
    @property
    def ParseSettingsDoubleNumber () -> StringParserSettings: ...
    @property
    def ParseSettingsRealNumber () -> StringParserSettings: ...
    @property
    def ParseSettingsEmpty () -> StringParserSettings: ...
    @property
    def DefaultAngleUnitSystem (self) -> AngleUnitSystem: ...
    @DefaultAngleUnitSystem.setter
    def DefaultAngleUnitSystem (self, value : AngleUnitSystem) -> None: ...
    @property
    def DefaultLengthUnitSystem (self) -> UnitSystem: ...
    @DefaultLengthUnitSystem.setter
    def DefaultLengthUnitSystem (self, value : UnitSystem) -> None: ...
    def SetAllFieldsToFalse (self) -> None: ...
    def SetAllExpressionSettingsToFalse (self) -> None: ...
    @property
    def ParseLeadingWhiteSpace (self) -> bool: ...
    @ParseLeadingWhiteSpace.setter
    def ParseLeadingWhiteSpace (self, value : bool) -> None: ...
    @property
    def ParseArithmeticExpression (self) -> bool: ...
    @ParseArithmeticExpression.setter
    def ParseArithmeticExpression (self, value : bool) -> None: ...
    @property
    def ParseMathFunctions (self) -> bool: ...
    @ParseMathFunctions.setter
    def ParseMathFunctions (self, value : bool) -> None: ...
    @property
    def ParseExplicitFormulaExpression (self) -> bool: ...
    @ParseExplicitFormulaExpression.setter
    def ParseExplicitFormulaExpression (self, value : bool) -> None: ...
    @property
    def ParseUnaryMinus (self) -> bool: ...
    @ParseUnaryMinus.setter
    def ParseUnaryMinus (self, value : bool) -> None: ...
    @property
    def ParseUnaryPlus (self) -> bool: ...
    @ParseUnaryPlus.setter
    def ParseUnaryPlus (self, value : bool) -> None: ...
    @property
    def ParseSignificandIntegerPart (self) -> bool: ...
    @ParseSignificandIntegerPart.setter
    def ParseSignificandIntegerPart (self, value : bool) -> None: ...
    @property
    def ParseSignificandFractionalPart (self) -> bool: ...
    @ParseSignificandFractionalPart.setter
    def ParseSignificandFractionalPart (self, value : bool) -> None: ...
    @property
    def ParseSignificandDigitSeparators (self) -> bool: ...
    @ParseSignificandDigitSeparators.setter
    def ParseSignificandDigitSeparators (self, value : bool) -> None: ...
    @property
    def ParseScientificENotation (self) -> bool: ...
    @ParseScientificENotation.setter
    def ParseScientificENotation (self, value : bool) -> None: ...
    @property
    def ParseDAsExponentInScientificENotation (self) -> bool: ...
    @ParseDAsExponentInScientificENotation.setter
    def ParseDAsExponentInScientificENotation (self, value : bool) -> None: ...
    @property
    def ParseFullStopAsDecimalPoint (self) -> bool: ...
    @ParseFullStopAsDecimalPoint.setter
    def ParseFullStopAsDecimalPoint (self, value : bool) -> None: ...
    @property
    def ParseFullStopAsDigitSeparator (self) -> bool: ...
    @ParseFullStopAsDigitSeparator.setter
    def ParseFullStopAsDigitSeparator (self, value : bool) -> None: ...
    @property
    def ParseCommaAsDecimalPoint (self) -> bool: ...
    @ParseCommaAsDecimalPoint.setter
    def ParseCommaAsDecimalPoint (self, value : bool) -> None: ...
    @property
    def ParseCommaAsDigitSeparator (self) -> bool: ...
    @ParseCommaAsDigitSeparator.setter
    def ParseCommaAsDigitSeparator (self, value : bool) -> None: ...
    @property
    def ParseSpaceAsDigitSeparator (self) -> bool: ...
    @ParseSpaceAsDigitSeparator.setter
    def ParseSpaceAsDigitSeparator (self, value : bool) -> None: ...
    @property
    def ParseHyphenMinusAsNumberDash (self) -> bool: ...
    @ParseHyphenMinusAsNumberDash.setter
    def ParseHyphenMinusAsNumberDash (self, value : bool) -> None: ...
    @property
    def ParseHyphenAsNumberDash (self) -> bool: ...
    @ParseHyphenAsNumberDash.setter
    def ParseHyphenAsNumberDash (self, value : bool) -> None: ...
    @property
    def ParseRationalNumber (self) -> bool: ...
    @ParseRationalNumber.setter
    def ParseRationalNumber (self, value : bool) -> None: ...
    @property
    def ParsePi (self) -> bool: ...
    @ParsePi.setter
    def ParsePi (self, value : bool) -> None: ...
    @property
    def ParseMultiplication (self) -> bool: ...
    @ParseMultiplication.setter
    def ParseMultiplication (self, value : bool) -> None: ...
    @property
    def ParseDivision (self) -> bool: ...
    @ParseDivision.setter
    def ParseDivision (self, value : bool) -> None: ...
    @property
    def ParseAddition (self) -> bool: ...
    @ParseAddition.setter
    def ParseAddition (self, value : bool) -> None: ...
    @property
    def ParseSubtraction (self) -> bool: ...
    @ParseSubtraction.setter
    def ParseSubtraction (self, value : bool) -> None: ...
    @property
    def ParsePairedParentheses (self) -> bool: ...
    @ParsePairedParentheses.setter
    def ParsePairedParentheses (self, value : bool) -> None: ...
    @property
    def ParseIntegerDashFraction (self) -> bool: ...
    @ParseIntegerDashFraction.setter
    def ParseIntegerDashFraction (self, value : bool) -> None: ...
    @property
    def ParseFeetInches (self) -> bool: ...
    @ParseFeetInches.setter
    def ParseFeetInches (self, value : bool) -> None: ...
    @property
    def ParseArcDegreesMinutesSeconds (self) -> bool: ...
    @ParseArcDegreesMinutesSeconds.setter
    def ParseArcDegreesMinutesSeconds (self, value : bool) -> None: ...
    @property
    def ParseSurveyorsNotation (self) -> bool: ...
    @ParseSurveyorsNotation.setter
    def ParseSurveyorsNotation (self, value : bool) -> None: ...
    @property
    def PreferedLocaleId (self) -> UInt32: ...
    @PreferedLocaleId.setter
    def PreferedLocaleId (self, value : UInt32) -> None: ...
class GetBoxMode:
    All = 0
    Corner = 1
    ThreePoint = 2
    Vertical = 3
    Center = 4
class RhinoGet:
    def StringToCommandOptionName (stringToConvert : str) -> str: ...
    def StringToCommandOptionName (englishString : str, localizedString : str) -> LocalizeStringPair: ...
    def InGet (doc : RhinoDoc) -> bool: ...
    def InGetPoint (doc : RhinoDoc) -> bool: ...
    def InGetObject (doc : RhinoDoc) -> bool: ...
    def GetPoint (prompt : str, acceptNothing : bool) -> Tuple[Result, Point3d]: ...
    def GetPointOnMesh (meshObjectId : Guid, prompt : str, acceptNothing : bool) -> Tuple[Result, Point3d]: ...
    def GetPointOnMesh (meshObject : MeshObject, prompt : str, acceptNothing : bool) -> Tuple[Result, Point3d]: ...
    def GetColor (prompt : str, acceptNothing : bool, color : Color) -> Tuple[Result, Color]: ...
    def GetOneObject (prompt : str, acceptNothing : bool, filter : ObjectType) -> Tuple[Result, ObjRef]: ...
    def GetOneObject (prompt : str, acceptNothing : bool, filter : GetObjectGeometryFilter) -> Tuple[Result, ObjRef]: ...
    def GetMultipleObjects (prompt : str, acceptNothing : bool, filter : ObjectType) -> Tuple[Result, Set(ObjRef)]: ...
    def GetMultipleObjects (prompt : str, acceptNothing : bool, filter : GetObjectGeometryFilter) -> Tuple[Result, Set(ObjRef)]: ...
    def GetString (prompt : str, acceptNothing : bool, outputString : str) -> Tuple[Result, str]: ...
    def GetBool (prompt : str, acceptNothing : bool, offPrompt : str, onPrompt : str, boolValue : bool) -> Tuple[Result, bool]: ...
    def GetNumber (prompt : str, acceptNothing : bool, outputNumber : float, lowerLimit : float, upperLimit : float) -> Tuple[Result, float]: ...
    def GetNumber (prompt : str, acceptNothing : bool, outputNumber : float) -> Tuple[Result, float]: ...
    def GetInteger (prompt : str, acceptNothing : bool, outputNumber : int) -> Tuple[Result, int]: ...
    def GetInteger (prompt : str, acceptNothing : bool, outputNumber : int, lowerLimit : int, upperLimit : int) -> Tuple[Result, int]: ...
    def GetPlane () -> Tuple[Result, Plane]: ...
    def GetRectangle () -> Tuple[Result, Set(Point3d)]: ...
    def GetRectangle (firstPrompt : str) -> Tuple[Result, Set(Point3d)]: ...
    def GetRectangleWithCounts (xMin : int, xCount : int, yMin : int, yCount : int) -> Tuple[Result, int, int, Set(Point3d)]: ...
    def GetBoxWithCounts (xMin : int, xCount : int, yMin : int, yCount : int, zMin : int, zCount : int) -> Tuple[Result, int, int, int, Set(Point3d)]: ...
    def GetRectangle (mode : GetBoxMode, firstPoint : Point3d, prompts : Iterable[str]) -> Tuple[Result, Set(Point3d)]: ...
    def Get2dRectangle (solidPen : bool) -> Tuple[Result, Rectangle, RhinoView]: ...
    def GetBox () -> Tuple[Result, Box]: ...
    def GetBox (mode : GetBoxMode, basePoint : Point3d, prompt1 : str, prompt2 : str, prompt3 : str) -> Tuple[Result, Box]: ...
    def GetGrips (prompt : str) -> Tuple[Result, Set(GripObject)]: ...
    def GetGrip (prompt : str) -> Tuple[Result, GripObject]: ...
    def GetSpiral () -> Tuple[Result, NurbsCurve]: ...
    def GetHelix () -> Tuple[Result, NurbsCurve]: ...
    def GetLine () -> Tuple[Result, Line]: ...
    def GetPolyline () -> Tuple[Result, Polyline]: ...
    def GetPolygon (numberSides : int, inscribed : bool) -> Tuple[Result, int, bool, Polyline]: ...
    def GetArc () -> Tuple[Result, Arc]: ...
    def GetCircle () -> Tuple[Result, Circle]: ...
    def GetLinearDimension () -> Tuple[Result, LinearDimension]: ...
    def GetView (commandPrompt : str) -> Tuple[Result, RhinoView]: ...
    def GetAngle (commandPrompt : str, basePoint : Point3d, referencePoint : Point3d, defaultAngleRadians : float) -> Tuple[Result, float]: ...
    @property
    def AllBitmapFileTypes () -> BitmapFileTypes: ...
    def GetFileName (mode : GetFileNameMode, defaultName : str, title : str, parent : Object, fileTypes : BitmapFileTypes) -> str: ...
    def GetFileName (mode : GetFileNameMode, defaultName : str, title : str, parent : Object) -> str: ...
    def GetFileNameScripted (mode : GetFileNameMode, defaultName : str) -> str: ...
    def GetPrintWindow (settings : ViewCaptureSettings) -> Tuple[Result, ViewCaptureSettings]: ...
class GetResult:
    NoResult = 0
    Cancel = 1
    Nothing = 2
    Option = 3
    Number = 4
    Color = 5
    Undo = 6
    Miss = 7
    Point = 8
    Point2d = 9
    Line2d = 10
    Rectangle2d = 11
    Object = 12
    String = 13
    CustomMessage = 14
    Timeout = 15
    Circle = 16
    Plane = 17
    Cylinder = 18
    Sphere = 19
    Angle = 20
    Distance = 21
    Direction = 22
    Frame = 23
    ExitRhino = 268435455
    User5 = 4294967291
    User4 = 4294967292
    User3 = 4294967293
    User2 = 4294967294
    User1 = 4294967295
class BitmapFileTypes:
    bmp = 1
    jpg = 2
    pcx = 4
    png = 8
    tif = 16
    tga = 32
