from typing import Tuple, Set, Iterable, List

class DisplayRenderSettings:
    @property
    def CullBackFaces (self) -> bool: ...
    @property
    def ForceFlatShading (self) -> bool: ...
    @property
    def SceneLightingOn (self) -> bool: ...
class Environment:
class Skylight:
    @property
    def Enabled (self) -> bool: ...
    @property
    def UsesCustomEnvironment (self) -> bool: ...
    @property
    def ShadowIntensity (self) -> float: ...
    def ToString (self) -> str: ...
class Light:
    @property
    def Id (self) -> Guid: ...
    @property
    def IdCrc (self) -> UInt32: ...
    @property
    def Data (self) -> Light: ...
    @property
    def ChangeType (self) -> Event: ...
class DynamicObjectTransform:
    @property
    def MeshInstanceId (self) -> UInt32: ...
    @property
    def Transform (self) -> Transform: ...
    def ToString (self) -> str: ...
class ClippingPlane:
    @property
    def IsEnabled (self) -> bool: ...
    @property
    def Plane (self) -> Plane: ...
    @property
    def Attributes (self) -> ObjectAttributes: ...
    @property
    def Id (self) -> Guid: ...
    @property
    def ViewIds (self) -> List: ...
class GroundPlane:
    @property
    def IsShadowOnly (self) -> bool: ...
    @property
    def Altitude (self) -> float: ...
    @property
    def MaterialId (self) -> UInt32: ...
    @property
    def TextureScale (self) -> Vector2d: ...
    @property
    def TextureOffset (self) -> Vector2d: ...
    @property
    def TextureRotation (self) -> float: ...
    @property
    def Enabled (self) -> bool: ...
    @property
    def Crc (self) -> UInt32: ...
class MappingChannel:
    @property
    def Local (self) -> Transform: ...
    @property
    def Mapping (self) -> TextureMapping: ...
class MappingChannelCollection:
    @property
    def Count (self) -> int: ...
    @property
    def Item (self, i : int) -> MappingChannel: ...
    @property
    def Channels (self) -> Iterable[MappingChannel]: ...
class Mesh:
    def GetMeshes (self) -> Set(Mesh): ...
    def Id (self) -> Guid: ...
    @property
    def SingleMapping (self) -> MappingChannel: ...
    @property
    def Mapping (self) -> MappingChannelCollection: ...
    @property
    def Attributes (self) -> ObjectAttributes: ...
    @property
    def Object (self) -> RhinoObject: ...
class MeshInstance:
    @property
    def ReceiveShadows (self) -> bool: ...
    @property
    def CastShadows (self) -> bool: ...
    @property
    def InstanceId (self) -> UInt32: ...
    @property
    def MeshId (self) -> Guid: ...
    @property
    def GroupId (self) -> UInt32: ...
    @property
    def MeshIndex (self) -> int: ...
    @property
    def MaterialId (self) -> UInt32: ...
    @property
    def RenderMaterial (self) -> RenderMaterial: ...
    @property
    def Transform (self) -> Transform: ...
class Material:
    @property
    def MeshInstanceId (self) -> UInt32: ...
    @property
    def Id (self) -> UInt32: ...
    @property
    def MeshIndex (self) -> int: ...
class ChangeQueue:
    def CrcFromGuid (guid : Guid) -> UInt32: ...
    @property
    def IsPreview (self) -> bool: ...
    @property
    def ViewId (self) -> Guid: ...
    def OneShot (self) -> None: ...
    def CreateWorld (self) -> None: ...
    def CreateWorld (self, bFlushWhenReady : bool) -> None: ...
    def Flush (self) -> None: ...
    def GetQueueSkylight (self) -> Skylight: ...
    def GetQueueGroundPlane (self) -> GroundPlane: ...
    def GetQueueRenderSettings (self) -> RenderSettings: ...
    def GetQueueSun (self) -> Light: ...
    def GetQueueView (self) -> ViewInfo: ...
    def AreViewsEqual (self, aView : ViewInfo, bView : ViewInfo) -> bool: ...
    def GetQueueSceneBoundingBox (self) -> BoundingBox: ...
    def Dispose (self) -> None: ...
    def MaterialFromId (self, crc : UInt32) -> RenderMaterial: ...
    def EnvironmentIdForUsage (self, usage : Usage) -> UInt32: ...
    def EnvironmentForid (self, crc : UInt32) -> RenderEnvironment: ...
    @property
    def DisplayPipelineAttributes (self) -> DisplayPipelineAttributes: ...
    def ConvertCameraBasedLightToWorld (changequeue : ChangeQueue, light : Light, vp : ViewInfo) -> None: ...
class FrameBufferFillMode:
    None = 0
    DefaultColor = 1
    SolidColor = 2
    Gradient2Color = 3
    Gradient4Color = 4
    Bitmap = 5
    Renderer = 6
    Transparent = 7
    Force32Bit = 4294967295
class Event:
    Added = 0
    Deleted = 1
    Undeleted = 2
    Modified = 3
    Sorted = 4
class BakingFunctions:
    None = 0
    Decals = 1
    ProceduralTextures = 2
    CustomObjectMappings = 4
    WcsBasedMappings = 8
    MultipleMappingChannels = 16
    NoRepeatTextures = 32
    All = 4294967295
