from typing import Tuple, Set, Iterable, List

class Modes:
    Unset = 0
    Grid = 1
    List = 2
    Tree = 3
class Shapes:
    Square = 0
    Wide = 1
class Sizes:
    Unset = 0
    Tiny = 1
    Small = 2
    Medium = 3
    Large = 4
class MetaData:
    def __init__(self, pMetaData : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def Geometry (self) -> str: ...
    def ContentInstanceId (self) -> Guid: ...
class AssignBys:
    Unset = 0
    Layer = 1
    Parent = 2
    Object = 3
    Varies = 4
    PlugIn = 5
class Usage:
    kBackground = 1
    kReflection = 2
    kSkylighting = 4
    kAny = 7
class RhinoSettings:
    def __init__(self, pRhinoSettings : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def GetRenderSettings (self) -> RenderSettings: ...
    def SetRenderSettings (self, renderSettings : RenderSettings) -> None: ...
    def ActiveView (self) -> RhinoView: ...
    def RenderingView (self) -> ViewInfo: ...
    def GetCustomRenderSizes (self) -> List: ...
    def ViewSupportsShading (self, view : RhinoView) -> bool: ...
    def GroundPlaneOnInViewDisplayMode (self, view : RhinoView) -> bool: ...
    def SetGroundPlaneOnInViewDisplayMode (self, view : RhinoView, bOn : bool) -> None: ...
class RdkSelectionNavigator:
    def __init__(self, pRhinoSettings : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def Clear (self) -> None: ...
    def Add (self, selectedContentArray : RenderContentCollection) -> None: ...
    def CanGoBackwards (self) -> bool: ...
    def CanGoForwards (self) -> bool: ...
    def GoBackwards (self, selectedContentArray : RenderContentCollection) -> Tuple[bool, RenderContentCollection]: ...
    def GoForwards (self, selectedContentArray : RenderContentCollection) -> Tuple[bool, RenderContentCollection]: ...
class ContentFactories:
    def __init__(self, pRdkContentFactories : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def FirstFactory (self) -> ContentFactory: ...
    def NextFactory (self) -> ContentFactory: ...
    def FindFactory (self, uuid : Guid) -> ContentFactory: ...
class ContentFactory:
    def __init__(self, pRdkContentFactory : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def NewContent (self) -> RenderContent: ...
    def Kind (self) -> RenderContentKind: ...
    def ContentTypeId (self) -> Guid: ...
class RdkModalEditContentBucket:
    def __init__(self, pRdkModalEditContentBucket : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def ContentsIn (self) -> RenderContentCollection: ...
    def SetContentsOut (self, collection : RenderContentCollection) -> None: ...
class RdkEdit:
    def __init__(self, pRdkEdit : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def Execute (self, collection : RenderContentCollection) -> bool: ...
