from typing import Tuple, Set, Iterable, List

class IRhRdkContentThumbnailList_Sizes:
    Tiny = 0
    Small = 1
    Medium = 2
    Large = 3
    Custom = 4
class Thumbnail:
    def __init__(self, pRdkThumbnail : IntPtr): ...
    @property
    def CppPointer (self) -> IntPtr: ...
    def Dispose (self) -> None: ...
    def Dib (self, dibOut : Bitmap) -> Tuple[Bitmap]: ...
    def GetDib (self) -> Bitmap: ...
    def GetDisplayRect (self, rectOut : RectangleF) -> Tuple[RectangleF]: ...
    def Id (self) -> Guid: ...
    def IsHot (self) -> bool: ...
    def IsSelected (self) -> bool: ...
    def Label (self) -> str: ...
class ThumbData:
    def __init__(self): ...
    def add_PropertyChanged (self, value : PropertyChangedEventHandler) -> None: ...
    def remove_PropertyChanged (self, value : PropertyChangedEventHandler) -> None: ...
    @property
    def TopLevel (self) -> bool: ...
    @property
    def InUseColor (self) -> List: ...
    @InUseColor.setter
    def InUseColor (self, value : List) -> None: ...
    @property
    def Content (self) -> RenderContent: ...
    @Content.setter
    def Content (self, value : RenderContent) -> None: ...
    @property
    def PreviewAppearance (self) -> PreviewAppearance: ...
    @PreviewAppearance.setter
    def PreviewAppearance (self, value : PreviewAppearance) -> None: ...
    @property
    def Image (self) -> Bitmap: ...
    @Image.setter
    def Image (self, value : Bitmap) -> None: ...
    @property
    def Children (self) -> List: ...
    @Children.setter
    def Children (self, value : List) -> None: ...
    @property
    def Parent (self) -> ThumbData: ...
    @Parent.setter
    def Parent (self, value : ThumbData) -> None: ...
    @property
    def Name (self) -> str: ...
    @Name.setter
    def Name (self, value : str) -> None: ...
    @property
    def Selected (self) -> bool: ...
    @Selected.setter
    def Selected (self, value : bool) -> None: ...
    @property
    def Type (self) -> str: ...
    @Type.setter
    def Type (self, value : str) -> None: ...
    @property
    def Intensity (self) -> str: ...
    @Intensity.setter
    def Intensity (self, value : str) -> None: ...
    @property
    def Id (self) -> Guid: ...
    @Id.setter
    def Id (self, value : Guid) -> None: ...
    @property
    def InUse (self) -> bool: ...
    @InUse.setter
    def InUse (self, value : bool) -> None: ...
    @property
    def Tags (self) -> List: ...
    @Tags.setter
    def Tags (self, value : List) -> None: ...
    def GetPreviewHeigth (thumb_size : Sizes, shape : Shapes) -> int: ...
    def GetPreviewWidth (thumb_size : Sizes, shape : Shapes) -> int: ...
class IRhRdkContentThumbnail:
    def TopLevelContent (self) -> RenderContent: ...
    def ChildContent (self) -> RenderContent: ...
    def GroupId (self) -> Guid: ...
class IRhRdkThumbnail:
    def Id (self) -> Guid: ...
    def Label (self) -> str: ...
    def IsSelected (self) -> bool: ...
    def IsHot (self) -> bool: ...
    def Dib (self, dibOut : Bitmap) -> Tuple[Bitmap]: ...
    def GetDisplayRect (self, rectOut : RectangleF) -> Tuple[RectangleF]: ...
    def GetDib (self) -> Bitmap: ...
class IRhRdkThumbnailList:
    def GetGridMetrics (self, w : int, h : int, ox : int, oy : int) -> Tuple[int, int, int, int]: ...
    def GetStatisticsHeaderHeight (self) -> None: ...
    def UUID (self) -> Guid: ...
    def Clear (self) -> None: ...
    def Add (self, t : Thumbnail) -> None: ...
    def Get (self, u : Guid) -> Tuple[IRhRdkThumbnail, Guid]: ...
    def Mode (self) -> IRhRdkThumbnailList_Modes: ...
    def SetMode (self, m : IRhRdkThumbnailList_Modes, b : bool) -> None: ...
    def Shape (self) -> IRhRdkThumbnailList_Shapes: ...
    def GetSize (self) -> IRhRdkContentThumbnailList_Sizes: ...
    def SetClientText (self, w : str) -> None: ...
    def SetCustomBitmapSize (self, w : int, h : int) -> None: ...
    def ShowLabels (self) -> bool: ...
    def SetShowLabels (self, b : bool) -> None: ...
class IRhRdkThumbnailList_Modes:
    Grid = 0
    List = 1
    Tree = 2
class IRhRdkThumbnailList_Shapes:
    Square = 0
    Wide = 1
class ThumbnailViewModelFactory(InternalRdkViewModelFactory):
    def __init__(self): ...
    def Get (self, id : Guid) -> IntPtr: ...
